/////////////////////////////////////////////////////////////////////////////
//                                                            (c) 1998/9 SNS
//  Configure
//                  Supporting code for TreeShare/PilotShare
//
//      Authors: George A. Smith & John R. Coleman
//      Why:     We felt the need.
//
//  LICENCE CONDITIONS:
//
//      The Authors consent to GNU General Public Licence for this code.
//      Other Licencing arrangements are possible.
//
//  NOTES:
//
//      Please notify us of any problems you find in the code.
//      Please notify us of any changes you make to this code that you
//              subsequently redistribute.
//      If you use this program, please tell us...
//
//      We can be contacted at:     PilotShare@SNS.to
//                          or:     TreeShare@SNS.to
//
//      Info:       http://SNS.to/PilotShare
//
//      If you redistribute, please leave the above in!
//
/////////////////////////////////////////////////////////////////////////////

#ifndef ConfigureH
#define ConfigureH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>

#include "cLogo.h"
//---------------------------------------------------------------------------
class TTreeShare : public TForm
{
    __published:    // IDE-managed Components
        TEdit *tb_SharedFolder;
        TEdit *tb_LocalFolder;
        TEdit *tb_LockFolder;
        TLabel *Label1;
        TLabel *Label2;
        TEdit *tb_RunCommand;
        TLabel *Label4;
        TLabel *Label3;
        TButton *bt_BrowseSharedFolder;
        TButton *tb_BrowseLocalFolder;
        TButton *bt_BrowweLockFolder;
        TButton *bt_BrowseRunCommand;
        TButton *bt_Save;
        TButton *bt_Cancel;
        TOpenDialog *FindRunProg;
        TLabel *lb_error;
        TLabel *Label5;
        TEdit *tb_RunCommandOptions;
        void __fastcall bt_BrowseRunCommandClick(TObject *Sender);
        void __fastcall bt_BrowweLockFolderClick(TObject *Sender);
        void __fastcall tb_BrowseLocalFolderClick(TObject *Sender);
        void __fastcall bt_BrowseSharedFolderClick(TObject *Sender);
        void __fastcall tb_LockFolderKeyPress(TObject *Sender, char &Key);
        void __fastcall tb_SharedFolderKeyPress(TObject *Sender, char &Key);
        void __fastcall tb_LocalFolderKeyPress(TObject *Sender, char &Key);
        void __fastcall tb_RunCommandKeyPress(TObject *Sender, char &Key);
        void __fastcall bt_SaveClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall bt_CancelClick(TObject *Sender);
        void __fastcall tb_LockFolderEnter(TObject *Sender);
        void __fastcall tb_SharedFolderEnter(TObject *Sender);
        void __fastcall tb_LocalFolderEnter(TObject *Sender);
        void __fastcall tb_RunCommandEnter(TObject *Sender);
        void __fastcall tb_RunCommandOptionsEnter(TObject *Sender);
    private:    // User declarations
        void __fastcall keyProcess( char key, TEdit * srcEdit, char *origText, TWinControl * changedTo );
        char * textboxHold;
        TLogo * ourOwner;
    public:     // User declarations
            __fastcall TTreeShare( TLogo * Owner);
        bool __fastcall TTreeShare::ValidateFields( void );
        char * __fastcall TTreeShare::getBoxText( TControl * box );
};
//---------------------------------------------------------------------------
extern PACKAGE TTreeShare *TreeShare;
//---------------------------------------------------------------------------
#endif
