/////////////////////////////////////////////////////////////////////////////
//                                                            (c) 1998/9 SNS
//  TokenLock
//                  Supporting code for TreeShare/PilotShare
//
//      Authors: George A. Smith & John R. Coleman
//      Why:     We felt the need.
//
//  LICENCE CONDITIONS:
//
//      The Authors consent to GNU General Public Licence for this code.
//      Other Licencing arrangements are possible.
//
//  NOTES:
//
//      Please notify us of any problems you find in the code.
//      Please notify us of any changes you make to this code that you
//              subsequently redistribute.
//      If you use this program, please tell us...
//
//      We can be contacted at:     PilotShare@SNS.to
//                          or:     TreeShare@SNS.to
//
//      Info:       http://SNS.to/PilotShare
//
//      If you redistribute, please leave the above in!
//
/////////////////////////////////////////////////////////////////////////////

#include "IncCmn.h"
//---------------------------------------------------------------------------
#include "TokenLock.h"
//---------------------------------------------------------------------------

#include <stdio.h>
#include <sys\timeb.h>
#include <fcntl.h>
#include <io.h>
#include <dos.h>

#include "WinTools.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

#define TOKEN_EXT   ".tokenlockfortreeshare"

#define FTIME_SECS(a)    ( ((a)&31 ) << 1 )
#define FTIME_MINS(a)    ( ((a) >> 5 ) & 63 )
#define FTIME_HOURS(a)   ( (a) >> 11 )

#define FTIME_DAY(a)     ( (a) & 31 )
#define FTIME_MONTH(a)   ( ((a) >> 5 ) & 31 )
#define FTIME_YEAR(a)    (( (a) >> 9 ) + 1980 )

static char * buildSearch( char * path )
{
    static char * myStr = NULL;

    if ( NULL != myStr )   delete [] myStr;
    return myStr = newSpace( path, "\\*", TOKEN_EXT );
}

static char * buildLockName( char * path, char * name )
{
    static char * myStr = NULL;

    if ( NULL != myStr )   delete [] myStr;
    return myStr = newSpace( path, "\\", name, TOKEN_EXT );
}

char * isExistingLock( char * path )
//  return NULL or lock name
{
    struct ffblk * ffblk;
    if ( NULL == ( ffblk = findFile( buildSearch( path )))  )   return NULL;

    static char lockName[MAXFILE];

    fnsplit(ffblk->ff_name, NULL, NULL, lockName, NULL);
    return lockName;
}

bool validateLock( char * path, char * name )
{
    return NULL != findFile(buildLockName( path, name ));
}

bool deleteLock( char * path, char * name )
    // returns TRUE if deleted
    //         FALSE is failure
{
    return deleteFile( buildLockName( path, name ) );
}

char * lockTime( char * path, char * name )
{
    struct ffblk * ffblk;
    if ( NULL == ( ffblk = findFile( buildLockName( path, name )))  )  return "??/??/???? ??:??";

    static char buf[20];
    sprintf( buf, "%2u/%02u/%04u %u:%02u",  FTIME_MONTH(ffblk->ff_fdate), FTIME_DAY(ffblk->ff_fdate), FTIME_YEAR(ffblk->ff_fdate),
                                            FTIME_HOURS(ffblk->ff_ftime), FTIME_MINS(ffblk->ff_ftime)  );
    return buf;
}

bool getLock( char * path, char * name )
{
    if ( NULL != isExistingLock( path ) )     return false;

    char * sp = buildLockName( path, name );
    int fh = open( sp, O_RDWR |O_CREAT|O_EXCL);

    if ( -1 == fh )        return false;

    write( fh, "1", 1 );
    close( fh );

    _rtl_chmod( sp, 1, FA_ARCH );

    return true;
}
