/////////////////////////////////////////////////////////////////////////////
//                                                            (c) 1998/9 SNS
//  WinErr
//                  Supporting code for TreeShare/PilotShare
//
//      Authors: George A. Smith & John R. Coleman
//      Why:     We felt the need.
//
//  LICENCE CONDITIONS:
//
//      The Authors consent to GNU General Public Licence for this code.
//      Other Licencing arrangements are possible.
//
//  NOTES:
//
//      Please notify us of any problems you find in the code.
//      Please notify us of any changes you make to this code that you
//              subsequently redistribute.
//      If you use this program, please tell us...
//
//      We can be contacted at:     PilotShare@SNS.to
//                          or:     TreeShare@SNS.to
//
//      Info:       http://SNS.to/PilotShare
//
//      If you redistribute, please leave the above in!
//
/////////////////////////////////////////////////////////////////////////////

#include "IncCmn.h"
//---------------------------------------------------------------------------
#include "WinErr.h"
//---------------------------------------------------------------------------

char * DecodeWindowsError( DWORD lasterr )
{
    switch ( lasterr )
    {
        default:   return "*UnKnwon Error*";
        case -8:    return "LZERROR UNKNOWNALG";

        case -7:    return "LZERROR BADVALUE";
        case -6:    return "LZERROR GLOBLOCK";
        case -5:    return "LZERROR GLOBALLOC";
        case -4:    return "LZERROR WRITE";
        case -3:    return "LZERROR READ";
        case -2:    return "LZERROR BADOUTHANDLE";
        case -1:    return "LZERROR BADINHANDLE";
        case 0:     return "NO ERROR / ERROR SUCCESS";
        case 1:     return "ERROR INVALID FUNCTION";
        case 2:     return "ERROR FILE NOT FOUND";
        case 3:     return "ERROR PATH NOT FOUND";
        case 4:     return "ERROR TOO MANY OPEN FILES";
        case 5:     return "ERROR ACCESS DENIED";
        case 6:     return "ERROR INVALID HANDLE";
        case 7:     return "ERROR ARENA TRASHED";
        case 8:     return "ERROR NOT ENOUGH MEMORY";
        case 9:     return "ERROR INVALID BLOCK";
        case 10:    return "ERROR BAD ENVIRONMENT";
        case 11:    return "ERROR BAD FORMAT";
        case 12:    return "ERROR INVALID ACCESS";
        case 13:    return "ERROR INVALID DATA";
        case 14:    return "ERROR OUTOFMEMORY";
        case 15:    return "ERROR INVALID DRIVE";
        case 16:    return "ERROR CURRENT DIRECTORY";
        case 17:    return "ERROR NOT SAME DEVICE";
        case 18:    return "ERROR NO MORE FILES";
        case 19:    return "ERROR WRITE PROTECT";
        case 20:    return "ERROR BAD UNIT";
        case 21:    return "ERROR NOT READY";
        case 22:    return "ERROR BAD COMMAND";
        case 23:    return "ERROR CRC";
        case 24:    return "ERROR BAD LENGTH";
        case 25:    return "ERROR SEEK";
        case 26:    return "ERROR NOT DOS DISK";
        case 27:    return "ERROR SECTOR NOT FOUND";
        case 28:    return "ERROR OUT OF PAPER";
        case 29:    return "ERROR WRITE FAULT";
        case 30:    return "ERROR READ FAULT";
        case 31:    return "ERROR GEN FAILURE";
        case 32:    return "ERROR SHARING VIOLATION";
        case 33:    return "ERROR LOCK VIOLATION";
        case 34:    return "ERROR WRONG DISK";
        case 36:    return "ERROR SHARING BUFFER EXCEEDED";
        case 38:    return "ERROR HANDLE EOF";
        case 39:    return "ERROR HANDLE DISK FULL";
        case 50:    return "ERROR NOT SUPPORTED";
        case 51:    return "ERROR REM NOT LIST";
        case 52:    return "ERROR DUP NAME";
        case 53:    return "ERROR BAD NETPATH";
        case 54:    return "ERROR NETWORK BUSY";
        case 55:    return "ERROR DEV NOT EXIST";
        case 56:    return "ERROR TOO MANY CMDS";
        case 57:    return "ERROR ADAP HDW ERR";
        case 58:    return "ERROR BAD NET RESP";
        case 59:    return "ERROR UNEXP NET ERR";
        case 60:    return "ERROR BAD REM ADAP";
        case 61:    return "ERROR PRINTQ FULL";
        case 62:    return "ERROR NO SPOOL SPACE";
        case 63:    return "ERROR PRINT CANCELLED";
        case 64:    return "ERROR NETNAME DELETED";
        case 65:    return "ERROR NETWORK ACCESS DENIED";
        case 66:    return "ERROR BAD DEV TYPE";
        case 67:    return "ERROR BAD NET NAME";
        case 68:    return "ERROR TOO MANY NAMES";
        case 69:    return "ERROR TOO MANY SESS";
        case 70:    return "ERROR SHARING PAUSED";
        case 71:    return "ERROR REQ NOT ACCEP";
        case 72:    return "ERROR REDIR PAUSED";
        case 80:    return "ERROR FILE EXISTS";
        case 82:    return "ERROR CANNOT MAKE";
        case 83:    return "ERROR FAIL I24";
        case 84:    return "ERROR OUT OF STRUCTURES";
        case 85:    return "ERROR ALREADY ASSIGNED";
        case 86:    return "ERROR INVALID PASSWORD";
        case 87:    return "ERROR INVALID PARAMETER";
        case 88:    return "ERROR NET WRITE FAULT";
        case 89:    return "ERROR NO PROC SLOTS";
        case 100:   return "ERROR TOO MANY SEMAPHORES";
        case 101:   return "ERROR EXCL SEM ALREADY OWNED";
        case 102:   return "ERROR SEM IS SET";
        case 103:   return "ERROR TOO MANY SEM REQUESTS";
        case 104:   return "ERROR INVALID AT INTERRUPT TIME";
        case 105:   return "ERROR SEM OWNER DIED";
        case 106:   return "ERROR SEM USER LIMIT";
        case 107:   return "ERROR DISK CHANGE";
        case 108:   return "ERROR DRIVE LOCKED";
        case 109:   return "ERROR BROKEN PIPE";
        case 110:   return "ERROR OPEN FAILED";
        case 111:   return "ERROR BUFFER OVERFLOW";
        case 112:   return "ERROR DISK FULL";
        case 113:   return "ERROR NO MORE SEARCH HANDLES";
        case 114:   return "ERROR INVALID TARGET HANDLE";
        case 117:   return "ERROR INVALID CATEGORY";
        case 118:   return "ERROR INVALID VERIFY SWITCH";
        case 119:   return "ERROR BAD DRIVER LEVEL";
        case 120:   return "ERROR CALL NOT IMPLEMENTED";
        case 121:   return "ERROR SEM TIMEOUT";
        case 122:   return "ERROR INSUFFICIENT BUFFER";
        case 123:   return "ERROR INVALID NAME";
        case 124:   return "ERROR INVALID LEVEL";
        case 125:   return "ERROR NO VOLUME LABEL";
        case 126:   return "ERROR MOD NOT FOUND";
        case 127:   return "ERROR PROC NOT FOUND";
        case 128:   return "ERROR WAIT NO CHILDREN";
        case 129:   return "ERROR CHILD NOT COMPLETE";
        case 130:   return "ERROR DIRECT ACCESS HANDLE";
        case 131:   return "ERROR NEGATIVE SEEK";
        case 132:   return "ERROR SEEK ON DEVICE";
        case 133:   return "ERROR IS JOIN TARGET";
        case 134:   return "ERROR IS JOINED";
        case 135:   return "ERROR IS SUBSTED";
        case 136:   return "ERROR NOT JOINED";
        case 137:   return "ERROR NOT SUBSTED";
        case 138:   return "ERROR JOIN TO JOIN";
        case 139:   return "ERROR SUBST TO SUBST";
        case 140:   return "ERROR JOIN TO SUBST";
        case 141:   return "ERROR SUBST TO JOIN";
        case 142:   return "ERROR BUSY DRIVE";
        case 143:   return "ERROR SAME DRIVE";
        case 144:   return "ERROR DIR NOT ROOT";
        case 145:   return "ERROR DIR NOT EMPTY";
        case 146:   return "ERROR IS SUBST PATH";
        case 147:   return "ERROR IS JOIN PATH";
        case 148:   return "ERROR PATH BUSY";
        case 149:   return "ERROR IS SUBST TARGET";
        case 150:   return "ERROR SYSTEM TRACE";
        case 151:   return "ERROR INVALID EVENT COUNT";
        case 152:   return "ERROR TOO MANY MUXWAITERS";
        case 153:   return "ERROR INVALID LIST FORMAT";
        case 154:   return "ERROR LABEL TOO LONG";
        case 155:   return "ERROR TOO MANY TCBS";
        case 156:   return "ERROR SIGNAL REFUSED";
        case 157:   return "ERROR DISCARDED";
        case 158:   return "ERROR NOT LOCKED";
        case 159:   return "ERROR BAD THREADID ADDR";
        case 160:   return "ERROR BAD ARGUMENTS";
        case 161:   return "ERROR BAD PATHNAME";
        case 162:   return "ERROR SIGNAL PENDING";
        case 164:   return "ERROR MAX THRDS REACHED";
        case 167:   return "ERROR LOCK FAILED";
        case 170:   return "ERROR BUSY";
        case 173:   return "ERROR CANCEL VIOLATION";
        case 174:   return "ERROR ATOMIC LOCKS NOT SUPPORTED";
        case 180:   return "ERROR INVALID SEGMENT NUMBER";
        case 182:   return "ERROR INVALID ORDINAL";
        case 183:   return "ERROR ALREADY EXISTS";
        case 186:   return "ERROR INVALID FLAG NUMBER";
        case 187:   return "ERROR SEM NOT FOUND";
        case 188:   return "ERROR INVALID STARTING CODESEG";
        case 189:   return "ERROR INVALID STACKSEG";
        case 190:   return "ERROR INVALID MODULETYPE";
        case 191:   return "ERROR INVALID EXE SIGNATURE";
        case 192:   return "ERROR EXE MARKED INVALID";
        case 193:   return "ERROR BAD EXE FORMAT";
        case 194:   return "ERROR ITERATED DATA EXCEEDS 64k";
        case 195:   return "ERROR INVALID MINALLOCSIZE";
        case 196:   return "ERROR DYNLINK FROM INVALID RING";
        case 197:   return "ERROR IOPL NOT ENABLED";
        case 198:   return "ERROR INVALID SEGDPL";
        case 199:   return "ERROR AUTODATASEG EXCEEDS 64k";
        case 200:   return "ERROR RING2SEG MUST BE MOVABLE";
        case 201:   return "ERROR RELOC CHAIN XEEDS SEGLIM";
        case 202:   return "ERROR INFLOOP IN RELOC CHAIN";
        case 203:   return "ERROR ENVVAR NOT FOUND";
        case 205:   return "ERROR NO SIGNAL SENT";
        case 206:   return "ERROR FILENAME EXCED RANGE";
        case 207:   return "ERROR RING2 STACK IN USE";
        case 208:   return "ERROR META EXPANSION TOO LONG";
        case 209:   return "ERROR INVALID SIGNAL NUMBER";
        case 210:   return "ERROR THREAD 1 INACTIVE";
        case 212:   return "ERROR LOCKED";
        case 214:   return "ERROR TOO MANY MODULES";
        case 215:   return "ERROR NESTING NOT ALLOWED";
        case 230:   return "ERROR BAD PIPE";
        case 231:   return "ERROR PIPE BUSY";
        case 232:   return "ERROR NO DATA";
        case 233:   return "ERROR PIPE NOT CONNECTED";
        case 234:   return "ERROR MORE DATA";
        case 240:   return "ERROR VC DISCONNECTED";
        case 254:   return "ERROR INVALID EA NAME";
        case 255:   return "ERROR EA LIST INCONSISTENT";
        case 259:   return "ERROR NO MORE ITEMS";
        case 266:   return "ERROR CANNOT COPY";
        case 267:   return "ERROR DIRECTORY";
        case 275:   return "ERROR EAS DIDNT FIT";
        case 276:   return "ERROR EA FILE CORRUPT";
        case 277:   return "ERROR EA TABLE FULL";
        case 278:   return "ERROR INVALID EA HANDLE";
        case 282:   return "ERROR EAS NOT SUPPORTED";
        case 288:   return "ERROR NOT OWNER";
        case 298:   return "ERROR TOO MANY POSTS";
        case 317:   return "ERROR MR MID NOT FOUND";
        case 487:   return "ERROR INVALID ADDRESS";
        case 534:   return "ERROR ARITHMETIC OVERFLOW";
        case 535:   return "ERROR PIPE CONNECTED";
        case 536:   return "ERROR PIPE LISTENING";
        case 994:   return "ERROR EA ACCESS DENIED";
        case 995:   return "ERROR OPERATION ABORTED";
        case 996:   return "ERROR IO INCOMPLETE";
        case 997:   return "ERROR IO PENDING";
        case 998:   return "ERROR NOACCESS";
        case 999:   return "ERROR SWAPERROR";
        case 1001:  return "ERROR STACK OVERFLOW";
        case 1002:  return "ERROR INVALID MESSAGE";
        case 1003:  return "ERROR CAN NOT COMPLETE";
        case 1004:  return "ERROR INVALID FLAGS";
        case 1005:  return "ERROR UNRECOGNIZED VOLUME";
        case 1006:  return "ERROR FILE INVALID";
        case 1007:  return "ERROR FULLSCREEN MODE";
        case 1008:  return "ERROR NO TOKEN";
        case 1009:  return "ERROR BADDB";
        case 1010:  return "ERROR BADKEY";
        case 1011:  return "ERROR CANTOPEN";
        case 1012:  return "ERROR CANTREAD";
        case 1013:  return "ERROR CANTWRITE";
        case 1014:  return "ERROR REGISTRY RECOVERED";
        case 1015:  return "ERROR REGISTRY CORRUPT";
        case 1016:  return "ERROR REGISTRY IO FAILED";
        case 1017:  return "ERROR NOT REGISTRY FILE";
        case 1018:  return "ERROR KEY DELETED";
        case 1019:  return "ERROR NO LOG SPACE";
        case 1020:  return "ERROR KEY HAS CHILDREN";
        case 1021:  return "ERROR CHILD MUST BE VOLATILE";
        case 1022:  return "ERROR NOTIFY ENUM DIR";
        case 1051:  return "ERROR DEPENDENT SERVICES RUNNING";
        case 1052:  return "ERROR INVALID SERVICE CONTROL";
        case 1053:  return "ERROR SERVICE REQUEST TIMEOUT";
        case 1054:  return "ERROR SERVICE NO THREAD";
        case 1055:  return "ERROR SERVICE DATABASE LOCKED";
        case 1056:  return "ERROR SERVICE ALREADY RUNNING";
        case 1057:  return "ERROR INVALID SERVICE ACCOUNT";
        case 1058:  return "ERROR SERVICE DISABLED";
        case 1059:  return "ERROR CIRCULAR DEPENDENCY";
        case 1060:  return "ERROR SERVICE DOES NOT EXIST";
        case 1061:  return "ERROR SERVICE CANNOT ACCEPT CTRL";
        case 1062:  return "ERROR SERVICE NOT ACTIVE";
        case 1063:  return "ERROR FAILED SERVICE CONTROLLER CONNECT";
        case 1064:  return "ERROR EXCEPTION IN SERVICE";
        case 1065:  return "ERROR DATABASE DOES NOT EXIST";
        case 1066:  return "ERROR SERVICE SPECIFIC ERROR";
        case 1067:  return "ERROR PROCESS ABORTED";
        case 1068:  return "ERROR SERVICE DEPENDENCY FAIL";
        case 1069:  return "ERROR SERVICE LOGON FAILED";
        case 1070:  return "ERROR SERVICE START HANG";
        case 1071:  return "ERROR INVALID SERVICE LOCK";
        case 1072:  return "ERROR SERVICE MARKED FOR DELETE";
        case 1073:  return "ERROR SERVICE EXISTS";
        case 1074:  return "ERROR ALREADY RUNNING LKG";
        case 1075:  return "ERROR SERVICE DEPENDENCY DELETED";
        case 1076:  return "ERROR BOOT ALREADY ACCEPTED";
        case 1077:  return "ERROR SERVICE NEVER STARTED";
        case 1078:  return "ERROR DUPLICATE SERVICE NAME";
        case 1100:  return "ERROR END OF MEDIA";
        case 1101:  return "ERROR FILEMARK DETECTED";
        case 1102:  return "ERROR BEGINNING OF MEDIA";
        case 1103:  return "ERROR SETMARK DETECTED";
        case 1104:  return "ERROR NO DATA DETECTED";
        case 1105:  return "ERROR PARTITION FAILURE";
        case 1106:  return "ERROR INVALID BLOCK LENGTH";
        case 1107:  return "ERROR DEVICE NOT PARTITIONED";
        case 1108:  return "ERROR UNABLE TO LOCK MEDIA";
        case 1109:  return "ERROR UNABLE TO UNLOAD MEDIA";
        case 1110:  return "ERROR MEDIA CHANGED";
        case 1111:  return "ERROR BUS RESET";
        case 1112:  return "ERROR NO MEDIA IN DRIVE";
        case 1113:  return "ERROR NO UNICODE TRANSLATION";
        case 1114:  return "ERROR DLL INIT FAILED";
        case 1115:  return "ERROR SHUTDOWN IN PROGRESS";
        case 1116:  return "ERROR NO SHUTDOWN IN PROGRESS";
        case 1117:  return "ERROR IO DEVICE";
        case 1118:  return "ERROR SERIAL NO DEVICE";
        case 1119:  return "ERROR IRQ BUSY";
        case 1120:  return "ERROR MORE WRITES";
        case 1121:  return "ERROR COUNTER TIMEOUT";
        case 1122:  return "ERROR FLOPPY ID MARK NOT FOUND";
        case 1123:  return "ERROR FLOPPY WRONG CYLINDER";
        case 1124:  return "ERROR FLOPPY UNKNOWN ERROR";
        case 1125:  return "ERROR FLOPPY BAD REGISTERS";
        case 1126:  return "ERROR DISK RECALIBRATE FAILED";
        case 1127:  return "ERROR DISK OPERATION FAILED";
        case 1128:  return "ERROR DISK RESET FAILED";
        case 1129:  return "ERROR EOM OVERFLOW";
        case 1130:  return "ERROR NOT ENOUGH SERVER MEMORY";
        case 1131:  return "ERROR POSSIBLE DEADLOCK";
        case 1200:  return "ERROR BAD DEVICE";
        case 1201:  return "ERROR CONNECTION UNAVAIL";
        case 1202:  return "ERROR DEVICE ALREADY REMEMBERED";
        case 1203:  return "ERROR NO NET OR BAD PATH";
        case 1204:  return "ERROR BAD PROVIDER";
        case 1205:  return "ERROR CANNOT OPEN PROFILE";
        case 1206:  return "ERROR BAD PROFILE";
        case 1207:  return "ERROR NOT CONTAINER";
        case 1208:  return "ERROR EXTENDED ERROR";
        case 1209:  return "ERROR INVALID GROUPNAME";
        case 1210:  return "ERROR INVALID COMPUTERNAME";
        case 1211:  return "ERROR INVALID EVENTNAME";
        case 1212:  return "ERROR INVALID DOMAINNAME";
        case 1213:  return "ERROR INVALID SERVICENAME";
        case 1214:  return "ERROR INVALID NETNAME";
        case 1215:  return "ERROR INVALID SHARENAME";
        case 1216:  return "ERROR INVALID PASSWORDNAME";
        case 1217:  return "ERROR INVALID MESSAGENAME";
        case 1218:  return "ERROR INVALID MESSAGEDEST";
        case 1219:  return "ERROR SESSION CREDENTIAL CONFLICT";
        case 1220:  return "ERROR REMOTE SESSION LIMIT EXCEEDED";
        case 1221:  return "ERROR DUP DOMAINNAME";
        case 1300:  return "ERROR NOT ALL ASSIGNED";
        case 1301:  return "ERROR SOME NOT MAPPED";
        case 1302:  return "ERROR NO QUOTAS FOR ACCOUNT";
        case 1303:  return "ERROR LOCAL USER SESSION KEY";
        case 1304:  return "ERROR NULL LM PASSWORD";
        case 1305:  return "ERROR UNKNOWN REVISION";
        case 1306:  return "ERROR REVISION MISMATCH";
        case 1307:  return "ERROR INVALID OWNER";
        case 1308:  return "ERROR INVALID PRIMARY GROUP";
        case 1309:  return "ERROR NO IMPERSONATION TOKEN";
        case 1310:  return "ERROR CANT DISABLE MANDATORY";
        case 1311:  return "ERROR NO LOGON SERVERS";
        case 1312:  return "ERROR NO SUCH LOGON SESSION";
        case 1313:  return "ERROR NO SUCH PRIVILEGE";
        case 1314:  return "ERROR PRIVILEGE NOT HELD";
        case 1315:  return "ERROR INVALID ACCOUNT NAME";
        case 1316:  return "ERROR USER EXISTS";
        case 1317:  return "ERROR NO SUCH USER";
        case 1318:  return "ERROR GROUP EXISTS";
        case 1319:  return "ERROR NO SUCH GROUP";
        case 1320:  return "ERROR MEMBER IN GROUP";
        case 1321:  return "ERROR MEMBER NOT IN GROUP";
        case 1322:  return "ERROR LAST ADMIN";
        case 1323:  return "ERROR WRONG PASSWORD";
        case 1324:  return "ERROR ILL FORMED PASSWORD";
        case 1325:  return "ERROR PASSWORD RESTRICTION";
        case 1326:  return "ERROR LOGON FAILURE";
        case 1327:  return "ERROR ACCOUNT RESTRICTION";
        case 1328:  return "ERROR INVALID LOGON HOURS";
        case 1329:  return "ERROR INVALID WORKSTATION";
        case 1330:  return "ERROR PASSWORD EXPIRED";
        case 1331:  return "ERROR ACCOUNT DISABLED";
        case 1332:  return "ERROR NONE MAPPED";
        case 1333:  return "ERROR TOO MANY LUIDS REQUESTED";
        case 1334:  return "ERROR LUIDS EXHAUSTED";
        case 1335:  return "ERROR INVALID SUB AUTHORITY";
        case 1336:  return "ERROR INVALID ACL";
        case 1337:  return "ERROR INVALID SID";
        case 1338:  return "ERROR INVALID SECURITY DESCR";
        case 1340:  return "ERROR BAD INHERITANCE ACL";
        case 1341:  return "ERROR SERVER DISABLED";
        case 1342:  return "ERROR SERVER NOT DISABLED";
        case 1343:  return "ERROR INVALID ID AUTHORITY";
        case 1344:  return "ERROR ALLOTTED SPACE EXCEEDED";
        case 1345:  return "ERROR INVALID GROUP ATTRIBUTES";
        case 1346:  return "ERROR BAD IMPERSONATION LEVEL";
        case 1347:  return "ERROR CANT OPEN ANONYMOUS";
        case 1348:  return "ERROR BAD VALIDATION CLASS";
        case 1349:  return "ERROR BAD TOKEN TYPE";
        case 1350:  return "ERROR NO SECURITY ON OBJECT";
        case 1351:  return "ERROR CANT ACCESS DOMAIN INFO";
        case 1352:  return "ERROR INVALID SERVER STATE";
        case 1353:  return "ERROR INVALID DOMAIN STATE";
        case 1354:  return "ERROR INVALID DOMAIN ROLE";
        case 1355:  return "ERROR NO SUCH DOMAIN";
        case 1356:  return "ERROR DOMAIN EXISTS";
        case 1357:  return "ERROR DOMAIN LIMIT EXCEEDED";
        case 1358:  return "ERROR INTERNAL DB CORRUPTION";
        case 1359:  return "ERROR INTERNAL ERROR";
        case 1360:  return "ERROR GENERIC NOT MAPPED";
        case 1361:  return "ERROR BAD DESCRIPTOR FORMAT";
        case 1362:  return "ERROR NOT LOGON PROCESS";
        case 1363:  return "ERROR LOGON SESSION EXISTS";
        case 1364:  return "ERROR NO SUCH PACKAGE";
        case 1365:  return "ERROR BAD LOGON SESSION STATE";
        case 1366:  return "ERROR LOGON SESSION COLLISION";
        case 1367:  return "ERROR INVALID LOGON TYPE";
        case 1368:  return "ERROR CANNOT IMPERSONATE";
        case 1369:  return "ERROR RXACT INVALID STATE";
        case 1370:  return "ERROR RXACT COMMIT FAILURE";
        case 1371:  return "ERROR SPECIAL ACCOUNT";
        case 1372:  return "ERROR SPECIAL GROUP";
        case 1373:  return "ERROR SPECIAL USER";
        case 1374:  return "ERROR MEMBERS PRIMARY GROUP";
        case 1375:  return "ERROR TOKEN ALREADY IN USE";
        case 1376:  return "ERROR NO SUCH ALIAS";
        case 1377:  return "ERROR MEMBER NOT IN ALIAS";
        case 1378:  return "ERROR MEMBER IN ALIAS";
        case 1379:  return "ERROR ALIAS EXISTS";
        case 1380:  return "ERROR LOGON NOT GRANTED";
        case 1381:  return "ERROR TOO MANY SECRETS";
        case 1382:  return "ERROR SECRET TOO LONG";
        case 1383:  return "ERROR INTERNAL DB ERROR";
        case 1384:  return "ERROR TOO MANY CONTEXT IDS";
        case 1385:  return "ERROR LOGON TYPE NOT GRANTED";
        case 1386:  return "ERROR NT CROSS ENCRYPTION REQUIRED";
        case 1387:  return "ERROR NO SUCH MEMBER";
        case 1388:  return "ERROR INVALID MEMBER";
        case 1389:  return "ERROR TOO MANY SIDS";
        case 1390:  return "ERROR LM CROSS ENCRYPTION REQUIRED";
        case 1391:  return "ERROR NO INHERITANCE";
        case 1392:  return "ERROR FILE CORRUPT";
        case 1393:  return "ERROR DISK CORRUPT";
        case 1394:  return "ERROR NO USER SESSION KEY";
        case 1400:  return "ERROR INVALID WINDOW HANDLE";
        case 1401:  return "ERROR INVALID MENU HANDLE";
        case 1402:  return "ERROR INVALID CURSOR HANDLE";
        case 1403:  return "ERROR INVALID ACCEL HANDLE";
        case 1404:  return "ERROR INVALID HOOK HANDLE";
        case 1405:  return "ERROR INVALID DWP HANDLE";
        case 1406:  return "ERROR TLW WITH WSCHILD";
        case 1407:  return "ERROR CANNOT FIND WND CLASS";
        case 1408:  return "ERROR WINDOW OF OTHER THREAD";
        case 1409:  return "ERROR HOTKEY ALREADY REGISTERED";
        case 1410:  return "ERROR CLASS ALREADY EXISTS";
        case 1411:  return "ERROR CLASS DOES NOT EXIST";
        case 1412:  return "ERROR CLASS HAS WINDOWS";
        case 1413:  return "ERROR INVALID INDEX";
        case 1414:  return "ERROR INVALID ICON HANDLE";
        case 1415:  return "ERROR PRIVATE DIALOG INDEX";
        case 1416:  return "ERROR LISTBOX ID NOT FOUND";
        case 1417:  return "ERROR NO WILDCARD CHARACTERS";
        case 1418:  return "ERROR CLIPBOARD NOT OPEN";
        case 1419:  return "ERROR HOTKEY NOT REGISTERED";
        case 1420:  return "ERROR WINDOW NOT DIALOG";
        case 1421:  return "ERROR CONTROL ID NOT FOUND";
        case 1422:  return "ERROR INVALID COMBOBOX MESSAGE";
        case 1423:  return "ERROR WINDOW NOT COMBOBOX";
        case 1424:  return "ERROR INVALID EDIT HEIGHT";
        case 1425:  return "ERROR DC NOT FOUND";
        case 1426:  return "ERROR INVALID HOOK FILTER";
        case 1427:  return "ERROR INVALID FILTER PROC";
        case 1428:  return "ERROR HOOK NEEDS HMOD";
        case 1429:  return "ERROR GLOBAL ONLY HOOK";
        case 1430:  return "ERROR JOURNAL HOOK SET";
        case 1431:  return "ERROR HOOK NOT INSTALLED";
        case 1432:  return "ERROR INVALID LB MESSAGE";
        case 1433:  return "ERROR SETCOUNT ON BAD LB";
        case 1434:  return "ERROR LB WITHOUT TABSTOPS";
        case 1435:  return "ERROR DESTROY OBJECT OF OTHER THREAD";
        case 1436:  return "ERROR CHILD WINDOW MENU";
        case 1437:  return "ERROR NO SYSTEM MENU";
        case 1438:  return "ERROR INVALID MSGBOX STYLE";
        case 1439:  return "ERROR INVALID SPI VALUE";
        case 1440:  return "ERROR SCREEN ALREADY LOCKED";
        case 1441:  return "ERROR HWNDS HAVE DIFFERENT PARENT";
        case 1442:  return "ERROR NOT CHILD WINDOW";
        case 1443:  return "ERROR INVALID GW COMMAND";
        case 1444:  return "ERROR INVALID THREAD ID";
        case 1445:  return "ERROR NON MDICHILD WINDOW";
        case 1446:  return "ERROR POPUP ALREADY ACTIVE";
        case 1447:  return "ERROR NO SCROLLBARS";
        case 1448:  return "ERROR INVALID SCROLLBAR RANGE";
        case 1449:  return "ERROR INVALID SHOWWIN COMMAND";
        case 1500:  return "ERROR EVENTLOG FILE CORRUPT";
        case 1501:  return "ERROR EVENTLOG CANT START";
        case 1502:  return "ERROR LOG FILE FULL";
        case 1503:  return "ERROR EVENTLOG FILE CHANGED";
        case 1700:  return "RPC S INVALID STRING BINDING";
        case 1701:  return "RPC S WRONG KIND OF BINDING";
        case 1702:  return "RPC S INVALID BINDING";
        case 1703:  return "RPC S PROTSEQ NOT SUPPORTED";
        case 1704:  return "RPC S INVALID RPC PROTSEQ";
        case 1705:  return "RPC S INVALID STRING UUID";
        case 1706:  return "RPC S INVALID ENDPOINT FORMAT";
        case 1707:  return "RPC S INVALID NET ADDR";
        case 1708:  return "RPC S NO ENDPOINT FOUND";
        case 1709:  return "RPC S INVALID TIMEOUT";
        case 1710:  return "RPC S OBJECT NOT FOUND";
        case 1711:  return "RPC S ALREADY REGISTERED";
        case 1712:  return "RPC S TYPE ALREADY REGISTERED";
        case 1713:  return "RPC S ALREADY LISTENING";
        case 1714:  return "RPC S NO PROTSEQS REGISTERED";
        case 1715:  return "RPC S NOT LISTENING";
        case 1716:  return "RPC S UNKNOWN MGR TYPE";
        case 1717:  return "RPC S UNKNOWN IF";
        case 1718:  return "RPC S NO BINDINGS";
        case 1719:  return "RPC S NO PROTSEQS";
        case 1720:  return "RPC S CANT CREATE ENDPOINT";
        case 1721:  return "RPC S OUT OF RESOURCES";
        case 1722:  return "RPC S SERVER UNAVAILABLE";
        case 1723:  return "RPC S SERVER TOO BUSY";
        case 1724:  return "RPC S INVALID NETWORK OPTIONS";
        case 1725:  return "RPC S NO CALL ACTIVE";
        case 1726:  return "RPC S CALL FAILED";
        case 1727:  return "RPC S CALL FAILED DNE";
        case 1728:  return "RPC S PROTOCOL ERROR";
        case 1730:  return "RPC S UNSUPPORTED TRANS SYN";
        case 1731:  return "RPC S SERVER OUT OF MEMORY";
        case 1732:  return "RPC S UNSUPPORTED TYPE";
        case 1733:  return "RPC S INVALID TAG";
        case 1734:  return "RPC S INVALID BOUND";
        case 1735:  return "RPC S NO ENTRY NAME";
        case 1736:  return "RPC S INVALID NAME SYNTAX";
        case 1737:  return "RPC S UNSUPPORTED NAME SYNTAX";
        case 1739:  return "RPC S UUID NO ADDRESS";
        case 1740:  return "RPC S DUPLICATE ENDPOINT";
        case 1741:  return "RPC S UNKNOWN AUTHN TYPE";
        case 1742:  return "RPC S MAX CALLS TOO SMALL";
        case 1743:  return "RPC S STRING TOO LONG";
        case 1744:  return "RPC S PROTSEQ NOT FOUND";
        case 1745:  return "RPC S PROCNUM OUT OF RANGE";
        case 1746:  return "RPC S BINDING HAS NO AUTH";
        case 1747:  return "RPC S UNKNOWN AUTHN SERVICE";
        case 1748:  return "RPC S UNKNOWN AUTHN LEVEL";
        case 1749:  return "RPC S INVALID AUTH IDENTITY";
        case 1750:  return "RPC S UNKNOWN AUTHZ SERVICE";
        case 1751:  return "EPT S INVALID ENTRY";
        case 1752:  return "EPT S CANT PERFORM OP";
        case 1753:  return "EPT S NOT REGISTERED";
        case 1755:  return "RPC S INCOMPLETE NAME";
        case 1756:  return "RPC S INVALID VERS OPTION";
        case 1757:  return "RPC S NO MORE MEMBERS";
        case 1759:  return "RPC S INTERFACE NOT FOUND";
        case 1760:  return "RPC S ENTRY ALREADY EXISTS";
        case 1761:  return "RPC S ENTRY NOT FOUND";
        case 1762:  return "RPC S NAME SERVICE UNAVAILABLE";
        case 1764:  return "RPC S CANNOT SUPPORT";
        case 1765:  return "RPC S NO CONTEXT AVAILABLE";
        case 1766:  return "RPC S INTERNAL ERROR";
        case 1767:  return "RPC S ZERO DIVIDE";
        case 1768:  return "RPC S ADDRESS ERROR";
        case 1769:  return "RPC S FP DIV ZERO";
        case 1770:  return "RPC S FP UNDERFLOW";
        case 1771:  return "RPC S FP OVERFLOW";
        case 1772:  return "RPC X NO MORE ENTRIES";
        case 1773:  return "RPC X SS CHAR TRANS OPEN FAIL";
        case 1774:  return "RPC X SS CHAR TRANS SHORT FILE";
        case 1775:  return "RPC X SS IN NULL CONTEXT";
        case 1776:  return "RPC X SS CONTEXT MISMATCH";
        case 1777:  return "RPC X SS CONTEXT DAMAGED";
        case 1778:  return "RPC X SS HANDLES MISMATCH";
        case 1779:  return "RPC X SS CANNOT GET CALL HANDLE";
        case 1780:  return "RPC X NULL REF POINTER";
        case 1781:  return "RPC X ENUM VALUE OUT OF RANGE";
        case 1782:  return "RPC X BYTE COUNT TOO SMALL";
        case 1783:  return "RPC X BAD STUB DATA";
        case 1784:  return "ERROR INVALID USER BUFFER";
        case 1785:  return "ERROR UNRECOGNIZED MEDIA";
        case 1786:  return "ERROR NO TRUST LSA SECRET";
        case 1787:  return "ERROR NO TRUST SAM ACCOUNT";
        case 1788:  return "ERROR TRUSTED DOMAIN FAILURE";
        case 1789:  return "ERROR TRUSTED RELATIONSHIP FAILURE";
        case 1790:  return "ERROR TRUST FAILURE";
        case 1791:  return "RPC S CALL IN PROGRESS";
        case 1792:  return "ERROR NETLOGON NOT STARTED";
        case 1793:  return "ERROR ACCOUNT EXPIRED";
        case 1794:  return "ERROR REDIRECTOR HAS OPEN HANDLES";
        case 1795:  return "ERROR PRINTER DRIVER ALREADY INSTALLED";
        case 1796:  return "ERROR UNKNOWN PORT";
        case 1797:  return "ERROR UNKNOWN PRINTER DRIVER";
        case 1798:  return "ERROR UNKNOWN PRINTPROCESSOR";
        case 1799:  return "ERROR INVALID SEPARATOR FILE";
        case 1800:  return "ERROR INVALID PRIORITY";
        case 1801:  return "ERROR INVALID PRINTER NAME";
        case 1802:  return "ERROR PRINTER ALREADY EXISTS";
        case 1803:  return "ERROR INVALID PRINTER COMMAND";
        case 1804:  return "ERROR INVALID DATATYPE";
        case 1805:  return "ERROR INVALID ENVIRONMENT";
        case 1806:  return "RPC S NO MORE BINDINGS";
        case 1807:  return "ERROR NOLOGON INTERDOMAIN TRUST ACCOUNT";
        case 1808:  return "ERROR NOLOGON WORKSTATION TRUST ACCOUNT";
        case 1809:  return "ERROR NOLOGON SERVER TRUST ACCOUNT";
        case 1810:  return "ERROR DOMAIN TRUST INCONSISTENT";
        case 1811:  return "ERROR SERVER HAS OPEN HANDLES";
        case 1812:  return "ERROR RESOURCE DATA NOT FOUND";
        case 1813:  return "ERROR RESOURCE TYPE NOT FOUND";
        case 1814:  return "ERROR RESOURCE NAME NOT FOUND";
        case 1815:  return "ERROR RESOURCE LANG NOT FOUND";
        case 1816:  return "ERROR NOT ENOUGH QUOTA";
        case 1898:  return "RPC S GROUP MEMBER NOT FOUND";
        case 1899:  return "EPT S CANT CREATE";
        case 1900:  return "RPC S INVALID OBJECT";
        case 2138:  return "ERROR NO NETWORK";
        case 2202:  return "ERROR BAD USERNAME";
        case 2250:  return "ERROR NOT CONNECTED";
        case 2401:  return "ERROR OPEN FILES";
        case 2404:  return "ERROR DEVICE IN USE";
        case 6118:  return "ERROR NO BROWSER SERVERS FOUND";
    }
}
