/////////////////////////////////////////////////////////////////////////////
//                                                            (c) 1998/9 SNS
//  cLogo
//                  Supporting code for TreeShare/PilotShare
//
//      Authors: George A. Smith & John R. Coleman
//      Why:     We felt the need.
//
//  LICENCE CONDITIONS:
//
//      The Authors consent to GNU General Public Licence for this code.
//      Other Licencing arrangements are possible.
//
//  NOTES:
//
//      Please notify us of any problems you find in the code.
//      Please notify us of any changes you make to this code that you
//              subsequently redistribute.
//      If you use this program, please tell us...
//
//      We can be contacted at:     PilotShare@SNS.to
//                          or:     TreeShare@SNS.to
//
//      Info:       http://SNS.to/PilotShare
//
//      If you redistribute, please leave the above in!
//
/////////////////////////////////////////////////////////////////////////////

#ifndef cLogoH
#define cLogoH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>

#include "WinAppControl.h"
//---------------------------------------------------------------------------

class TLogo : public TForm
{
    __published:    // IDE-managed Components
        TLabel *lb_Title;
        TTimer *zTimer;
        void __fastcall lb_TitleClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall zTimerTimer(TObject *Sender);

    private:    // User declarations
        int    curState;
        char * userName;
        char * lockPath;
        char * ourBaseName;

        WinAppControl   * zApp;
        char * errTitle;
        char * errMsg;
        bool   modeCancel;
        bool   modeReadOnly;
        bool   modeDeleteLock;

        enum STATES
        {
            ST_VIRGIN,
            ST_VALIDATE_INI,
            ST_GET_USERID,
            ST_GET_LOCK,
            ST_GET_DATA,
            ST_LAUNCH_APP,
            ST_APP_WAIT,
            ST_VALIDATE_LOCK,
            ST_RETURN_DATA,
            ST_DONE,
            ST_ERROR,
            ST_COUNT
        };
        void    __fastcall clearFlags( void );
        char *  __fastcall getOurName( char *full );
        char *  __fastcall getOurPathAndName( char *full );
        void    __fastcall editIni( void );
        bool    __fastcall obtainLock( void );
        bool    __fastcall verifyStillLocked( void );
        void    __fastcall doVirgin( void );
        void    __fastcall doValidateIni( void );
        void    __fastcall doGetLock( void );
        void    __fastcall doGetData( void );
        void    __fastcall doLaunchApp( void );
        void    __fastcall doAppWait( void );
        void    __fastcall doValidateLock( void );
        void    __fastcall doReturnData( void );
        void    __fastcall doDone( void );
        void    __fastcall doError( void );

    public:     // User declarations
        char * ourName;

                __fastcall TLogo(TComponent* Owner);
        void    __fastcall setErr( char * title, char * msg );
        void    __fastcall setErr( char * title, char * msg1, char * msg2 );
        void    __fastcall setCancel( void );
        void    __fastcall setDeleteLock( void );
        void    __fastcall setReadOnly( void );
};
//---------------------------------------------------------------------------
extern PACKAGE TLogo *Logo;
//---------------------------------------------------------------------------
#endif
