/////////////////////////////////////////////////////////////////////////////
//                                                            (c) 1998/9 SNS
//  cRegInfo
//                  Supporting code for TreeShare/PilotShare
//
//      Authors: George A. Smith & John R. Coleman
//      Why:     We felt the need.
//
//  LICENCE CONDITIONS:
//
//      The Authors consent to GNU General Public Licence for this code.
//      Other Licencing arrangements are possible.
//
//  NOTES:
//
//      Please notify us of any problems you find in the code.
//      Please notify us of any changes you make to this code that you
//              subsequently redistribute.
//      If you use this program, please tell us...
//
//      We can be contacted at:     PilotShare@SNS.to
//                          or:     TreeShare@SNS.to
//
//      Info:       http://SNS.to/PilotShare
//
//      If you redistribute, please leave the above in!
//
/////////////////////////////////////////////////////////////////////////////

#include "IncCmn.h"
//---------------------------------------------------------------------------
#include "cRegInfo.h"
//---------------------------------------------------------------------------

#include <fcntl.h>
#include <io.h>
#include <dos.h>

#include "WinErr.h"
#include "WinAppControl.h"
#include "WinTools.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
#pragma resource "*.dfm"
TRegInfo *RegInfo;

//---------------------------------------------------------------------------

__fastcall TRegInfo::TRegInfo(TComponent* Owner, char * basePathAndName) : TForm(Owner)
{
    char * temp  = getPath( basePathAndName );
    ourBaseName  = getBaseName( basePathAndName );

    if ( stricmp( ourBaseName, "PILOTSHARE" ) )
        ourBaseName = dynSpace( ourBaseName, "TreeShare" );
    else
        ourBaseName = dynSpace( ourBaseName, "PilotShare" );

    urlFileName = newSpace( temp, "/", ourBaseName, "_HomePage.url" );

    temp        = dynSpace( temp, ourBaseName, " home page" );
    lb_HomePage->SetTextBuf( temp );

    dynFree( temp );
}

//---------------------------------------------------------------------------

void __fastcall TRegInfo::FormClick(TObject *Sender)
{
    Close();
}

//---------------------------------------------------------------------------

void __fastcall TRegInfo::m_TextClick(TObject *Sender)
{
    //
}

//---------------------------------------------------------------------------

void __fastcall TRegInfo::m_TextDblClick(TObject *Sender)
{
    Close();
}

//---------------------------------------------------------------------------

void __fastcall TRegInfo::lb_HomePageClick(TObject *Sender)
{
    int fh = open( urlFileName, O_RDWR |O_CREAT);

    if ( -1 != fh )
    {
        char * page = newSpace( "[InternetShortcut]\nURL=http://sns.to/", ourBaseName, "\n" );
        write( fh, page, strlen(page) );
        close( fh );
        _rtl_chmod( urlFileName, 1, FA_ARCH );

        char * urlLauch = "runDLL32.exe url.dll,OpenURL";

        WinAppControl * zApp = new WinAppControl( urlLauch, urlFileName );
        zApp->launch_normal();

        delete zApp;
    }
}

//---------------------------------------------------------------------------

void __fastcall TRegInfo::FormDestroy(TObject *Sender)
{
    urlFileName = dynFree( urlFileName );
    ourBaseName = dynFree( ourBaseName );
}

//---------------------------------------------------------------------------
